package com.cirmuller.maidaddition.entity.brain;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.cirmuller.maidaddition.entity.behaviour.ChunkLoadingBehaviour;
import com.cirmuller.maidaddition.entity.memory.MemoryRegistry;
import com.cirmuller.maidaddition.entity.sensor.SensorRegistry;
import com.github.tartaricacid.touhoulittlemaid.api.entity.ai.IExtraMaidBrain;
import com.github.tartaricacid.touhoulittlemaid.entity.passive.EntityMaid;
import com.google.common.collect.ImmutableList;
import com.mojang.datafixers.util.Pair;
import java.util.ArrayList;
import java.util.List;
import net.minecraft.world.entity.ai.behavior.BehaviorControl;
import net.minecraft.world.entity.ai.memory.MemoryModuleType;
import net.minecraft.world.entity.ai.sensing.Sensor;
import net.minecraft.world.entity.ai.sensing.SensorType;
import net.minecraftforge.fml.ModList;

public class MaidBrain implements IExtraMaidBrain {
  public List<MemoryModuleType<?>> getExtraMemoryTypes() {
    List<MemoryModuleType<?>> list = new ArrayList<>();
    list.add((MemoryModuleType)MemoryRegistry.CAN_CHUNK_LOADED.get());
    if (ModList.get().isLoaded("create"))
      list.add((MemoryModuleType)MemoryRegistry.HAND_CRANK_TARGET.get()); 
    return list;
  }
  
  public List<SensorType<? extends Sensor<? super EntityMaid>>> getExtraSensorTypes() {
    List<SensorType<? extends Sensor<? super EntityMaid>>> list = new ArrayList<>();
    if (ModList.get().isLoaded("create"))
      list.add((SensorType<? extends Sensor<? super EntityMaid>>)SensorRegistry.HAND_CRANK_SENSOR.get()); 
    return list;
  }
  
  public List<Pair<Integer, BehaviorControl<? super EntityMaid>>> getCoreBehaviors() {
    Pair<Integer, BehaviorControl<? super EntityMaid>> chunkLoading = Pair.of(Integer.valueOf(5), new ChunkLoadingBehaviour());
    return ImmutableList.of(chunkLoading);
  }
}
